remove obsolete uses of `eend $?`
[grml-debootstrap.git] / grml-debootstrap
index 76c3648..3bcaae5 100755 (executable)
@@ -5,44 +5,34 @@
 # Bug-Reports:   see https://grml.org/bugs/
 # License:       This file is licensed under the GPL v2+
 ################################################################################
+# shellcheck disable=SC2001,SC2181
 
 # error_handler {{{
-[ -n "$REPORT_TRAP_ERR" ] || REPORT_TRAP_ERR='no'
-[ -n "$FAIL_TRAP_ERR" ] || FAIL_TRAP_ERR='no'
-
 error_handler() {
    last_exit_code="$?"
    last_bash_command="$BASH_COMMAND"
-   if [ "$REPORT_TRAP_ERR" = "yes" ]; then
-      echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
+   echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
 last bash command: $last_bash_command"
-   fi
-   if [ ! "$FAIL_TRAP_ERR" = "yes" ]; then
-      return
-   fi
    ## Check if "bailout" function is available.
    ## This is not the case in chroot-script.
    if command -v bailout >/dev/null 2>&1; then
       bailout 1
    else
-      echo 'FAIL_TRAP_ERR is set to "yes", exit 1.'
       exit 1
    fi
 }
 
-if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
-   set -e
-   set -E
-   set -o pipefail
-   trap "error_handler" ERR
-   export -f "error_handler"
-fi
+set -e
+set -E
+set -o pipefail
+trap "error_handler" ERR
+export -f "error_handler"
 # }}}
 
 # variables {{{
 PN="$(basename "$0")"
 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
-  VERSION="$(git --git-dir $(dirname "$(command -v "$0")")/.git describe | sed 's|^v||')"
+  VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
 else
   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
 fi
@@ -297,8 +287,7 @@ cleanup() {
         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
       else
         einfo "Unmounting $MNTPOINT"
-        umount "$MNTPOINT"
-        eend $?
+        umount "$MNTPOINT" || eend $?
       fi
 
       if [ -n "$STAGES" ] ; then
@@ -309,21 +298,19 @@ cleanup() {
       # remove directory only if we used the default with process id inside the name
       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
         einfo "Removing directory ${MNTPOINT}"
-        rmdir "$MNTPOINT"
-        eend $?
+        rmdir "$MNTPOINT" || eend $?
       fi
     fi
   fi
 
   if [ -n "${ORIG_TARGET}" ] ; then
     einfo "Removing loopback mount of file ${ORIG_TARGET}."
-    kpartx -d "${ORIG_TARGET}"
+    kpartx -d "${ORIG_TARGET}" || eend $?
     # Workaround for a bug in kpartx which doesn't clean up properly,
     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
     if dmsetup ls | grep -q "^${LOOP_PART} "; then
-      kpartx -d "/dev/${LOOP_DISK}" >/dev/null
+      kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
     fi
-    eend $?
   fi
 }
 
@@ -1028,14 +1015,16 @@ efi_support() {
 checkconfiguration()
 {
 
-if efi_support ; then
-  if [ -z "$_opt_efi" ] ; then
-    ewarn "EFI support detected but no --efi option given, please consider enabling it."
-  fi
-else
-  if [ -n "$_opt_efi" ] ; then
-     eerror "EFI option used but no EFI support detected."
-     bailout 1
+if [ -z "$VIRTUAL" ] ; then
+  if efi_support ; then
+    if [ -z "$_opt_efi" ] ; then
+      ewarn "EFI support detected but no --efi option given, please consider enabling it."
+    fi
+  else
+    if [ -n "$_opt_efi" ] ; then
+      eerror "EFI option used but no EFI support detected."
+      bailout 1
+    fi
   fi
 fi
 
@@ -1331,8 +1320,6 @@ mkfs() {
     if [ -n "${ARM_EFI_TARGET}" ] ; then
       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
-      eend $?
-
       MKFS_OPTS="$MKFS_OPTS -L LINUX"
     fi
 
@@ -1348,14 +1335,12 @@ mkfs() {
       else
         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
-        eend $?
       fi
     fi
 
     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
       einfo "Creating FAT filesystem on $EFI_TARGET"
       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
-      eend $?
     fi
 
     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
@@ -1433,7 +1418,6 @@ tunefs() {
   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
      $TUNE2FS "$TARGET" </dev/null
-     eend $?
   fi
 }
 # }}}
@@ -1452,14 +1436,12 @@ mount_target() {
        einfo "Mounting $TARGET to $MNTPOINT"
        mkdir -p "$MNTPOINT"
        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
-       eend $?
      fi
   fi
   if [ -n "$ISODIR" ] ; then
      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
      mkdir -p "$MNTPOINT/$ISODIR"
      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
-     eend $?
   fi
 }
 # }}}
@@ -1525,7 +1507,6 @@ prepare_vm() {
         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
-        eend $?
       fi
       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
       parted -s "${TARGET}" 'set 1 boot on'
@@ -1675,7 +1656,6 @@ grub_install() {
     einfo "Setting up bind-mount /run/udev"
     mkdir -p "${MNTPOINT}"/run/udev
     mount --bind /run/udev "${MNTPOINT}"/run/udev
-    eend $?
   fi
 
   if [ -n "${BOOT_APPEND}" ] ; then
@@ -1708,7 +1688,6 @@ grub_install() {
   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
     einfo "Unmounting bind-mount /run/udev"
     umount "${MNTPOINT}"/run/udev
-    eend $?
   fi
 
   umount "${MNTPOINT}"/proc
@@ -1892,9 +1871,6 @@ preparechroot() {
   # setup default locales
   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
 
-  # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
-  ( cd "${MNTPOINT}"/dev && tar zxf /etc/debootstrap/devices.tar.gz )
-
   # copy any existing files to chroot
   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
@@ -1950,22 +1926,18 @@ iface ${interface} inet dhcp
     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
     mkdir -p "${MNTPOINT}/etc/network"
     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
-    eend $?
   elif [ -n "$VIRTUAL" ] ; then
     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
     mkdir -p "${MNTPOINT}/etc/network"
     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
-    eend $?
   elif [ -r /etc/network/interfaces ] ; then
     einfo "Copying /etc/network/interfaces from host to target system"
     mkdir -p "${MNTPOINT}/etc/network"
     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
-    eend $?
   else
     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
     mkdir -p "${MNTPOINT}/etc/network"
     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
-    eend $?
   fi
 
   # install config file providing some example entries
@@ -2026,7 +1998,6 @@ iface ${interface} inet dhcp
     einfo "Setting up bind-mount /run/udev"
     mkdir -p "${MNTPOINT}"/run/udev
     mount --bind /run/udev "${MNTPOINT}"/run/udev
-    eend $?
   fi
 }
 # }}}
@@ -2044,7 +2015,7 @@ execute_pre_scripts() {
     for script in "${pre_scripts}"/* ; do
       if [ -x "$script" ] ; then
         einfo "Executing pre-script $script"
-        "$script" ; eend $?
+        "$script"
       fi
     done
   fi
@@ -2069,7 +2040,7 @@ execute_post_scripts() {
     for script in "${post_scripts}"/* ; do
       if [ -x "$script" ] ; then
         einfo "Executing post-script $script"
-        "$script" ; eend $?
+        "$script"
       fi
     done
   fi
@@ -2126,7 +2097,6 @@ chrootscript() {
   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
     einfo "Removing chroot-script again"
     rm -f "${MNTPOINT}/bin/chroot-script"
-    eend $?
   else
     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
   fi
@@ -2145,7 +2115,6 @@ umount_chroot() {
      if grep -q "$ISODIR" /proc/mounts ; then
         einfo "Unmount $MNTPOINT/$ISODIR"
         umount "$MNTPOINT/$ISODIR"
-        eend $?
      fi
   fi
 
@@ -2153,13 +2122,11 @@ umount_chroot() {
     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
       einfo "Unmounting bind-mount /run/udev"
       umount "${MNTPOINT}"/run/udev
-      eend $?
     fi
 
      if [ -n "$PARTITION" ] ; then
         einfo "Unmount $MNTPOINT"
         umount "$MNTPOINT"
-        eend $?
      fi
   fi
 }
@@ -2176,7 +2143,6 @@ fscktool() {
    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
    "$FSCKTOOL" "$TARGET"
-   eend $?
  fi
 }
 # }}}
@@ -2194,7 +2160,6 @@ remove_configs() {
 
   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
   rm -rf "${MNTPOINT}"/etc/debootstrap/
-  eend $?
 }
 # }}}